(* ------------------------------------------------------ *)
(*                       LED.PAS                          *)
(*      Unit zur Einbindung von Blinkeffekten mit den     *)
(*                LED-Anzeigen der Tastatur.              *)
(*    (c) 1990 Ulrich Schmitz, Gerald Arend & TOOLBOX     *)
(* ------------------------------------------------------ *)
UNIT LED;

INTERFACE

USES Crt;

CONST
  ZeitAn  : WORD = 100;   { Verzgerungen in Millisekunden }
  ZeitAus : WORD = 100;

VAR
  Muster : BYTE;        { Bitmuster fr bergabe an SetLED }


  PROCEDURE Blink(Caps, Num, Scroll: BOOLEAN; Count : BYTE);

IMPLEMENTATION

{$F+}
{$L SHOW_LED.OBJ}

  PROCEDURE _show_led(Muster: WORD); EXTERNAL;

{$F-}

  PROCEDURE Blink(Caps, Num, Scroll: BOOLEAN; Count : BYTE);
             { Die LEDs werden gesetzt und wieder gelscht }
  VAR
    n : BYTE;
  BEGIN
    Muster := 0;
    IF Caps   THEN Muster := Muster OR 4;
    IF Num    THEN Muster := Muster OR 2;
    IF Scroll THEN Muster := Muster OR 1;
    FOR n := 1 TO Count DO BEGIN
      _show_led(Muster);
      Delay(ZeitAn);
      _show_led(0);
      Delay(ZeitAus);
    END;
  END;

END.
(* ------------------------------------------------------ *)
(*                  Ende von LED.PAS                      *)

